/*
 * Licensed Material - Property of IBM
 * (C) Copyright IBM Corp. 2012 - All Rights Reserved.
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 */
package com.ibm.junit3.tests;

import static org.junit.Assert.assertArrayEquals;
import static org.junit.Assert.assertTrue;

import org.junit.Test;

import com.ibm.calculator.junit.tests.SimpleIntegerCalculator;

import junit.framework.TestCase;

public class CalculatorJUnit3Tests extends TestCase {

	/*
	 * This test is intended to pass 
	 */
	public void testAddition() {
		SimpleIntegerCalculator calc = new SimpleIntegerCalculator();
		assertTrue(calc.add(5, 4) == 9);
	}

	/*
	 * This test is intended to pass 
	 */
	public void testMemory() {
		SimpleIntegerCalculator calc = new SimpleIntegerCalculator();
		int result = calc.add(10, 5);
		calc.save(result);
		assertNotNull(calc.getMemory());
	}

	/*
	 * This test is intended to pass 
	 */
	public void testPower() {
		SimpleIntegerCalculator calc = new SimpleIntegerCalculator();
		assertFalse(calc.power(2, 2) == 44);
	}

	/*
	 * This test is intended to pass 
	 */
	public void testEmptyMemory() {
		SimpleIntegerCalculator calc = new SimpleIntegerCalculator();
		calc.setMemory(new Integer(calc.multiply(3, 4)));
		calc.clearMemory();
		assertNull(calc.getMemory());
	}

	/*
	 * This test is intended to pass 
	 */
	public void testSameResults() {
		SimpleIntegerCalculator calc = new SimpleIntegerCalculator();
		assertEquals(calc.multiply(3, 2), calc.factorial(3));
	}

	/*
	 * This test is intended to pass 
	 */
	public void testComplexOperation() {
		SimpleIntegerCalculator calc = new SimpleIntegerCalculator();
		int result = calc.add(calc.factorial(4), calc.fibonacci(3));
		assertTrue(result == 26);
	}

	/*
	 * This test is intended to pass 
	 */
	public void testEqualArrays() {
		SimpleIntegerCalculator calc = new SimpleIntegerCalculator();
		int size = 5;
		int[] expecteds = new int[5];
		expecteds[0] = 0;
		expecteds[1] = 1;
		expecteds[2] = 1;
		expecteds[3] = 2;
		expecteds[4] = 3;
		int[] series2 = new int[5];
		for (int i = 0; i <= size - 1; i++) {
			series2[i] = calc.fibonacci(i);
		}
		assertArrayEquals(expecteds, series2);
	}

	/*
	 * This test is intended to fail 
	 */
	public void testSubtraction() {
		SimpleIntegerCalculator calc = new SimpleIntegerCalculator();
		int result = 3;
		assertTrue(result == calc.subtract(10, 5));
	}

}
