/*
 * Licensed Material - Property of IBM
 * (C) Copyright IBM Corp. 2012 - All Rights Reserved.
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 */
package com.ibm.junit4.tests;


import org.junit.* ;

import com.ibm.calculator.junit.tests.SimpleIntegerCalculator;
import static org.junit.Assert.* ;



public class CalculatorJUnit4Tests {

	/*
	 * This test is intended to pass 
	 */
	   @Test
	   public void test_addition() {
	      SimpleIntegerCalculator calc = new SimpleIntegerCalculator();
	      assertTrue(calc.add(5, 4) == 9) ;
	   }

		/*
		 * This test is intended to pass 
		 */
	   @Test
	   public void test_memory() {
	      SimpleIntegerCalculator calc = new SimpleIntegerCalculator();
	      int result = calc.add(10,5);
	      calc.save(result); 
	      assertNotNull(calc.getMemory()) ; 
	   }
	   
		/*
		 * This test is intended to pass 
		 */
	   @Test
	   public void test_power() {
	      SimpleIntegerCalculator calc = new SimpleIntegerCalculator();
	      assertFalse(calc.power(2, 2) == 44) ;
	   }
	   
		/*
		 * This test is intended to pass 
		 */
	   @Test
	   public void test_empty_memory() {
	      SimpleIntegerCalculator calc = new SimpleIntegerCalculator();
	      calc.setMemory(new Integer(calc.multiply(3, 4)));
	      calc.clearMemory();
	      assertNull(calc.getMemory());
	   }
	   
		/*
		 * This test is intended to pass 
		 */
	   @Test
	   public void test_same_results() {
	      SimpleIntegerCalculator calc = new SimpleIntegerCalculator();
	      assertEquals(calc.multiply(3, 2), calc.factorial(3));
	   }
	   	   
		/*
		 * This test is intended to pass 
		 */
	   @Test
	   public void test_complex_operation() {
	      SimpleIntegerCalculator calc = new SimpleIntegerCalculator();
	      int result = calc.add(calc.factorial(4), calc.fibonacci(3));
	      assertTrue(result == 26 ) ; 
	   }
	   
		/*
		 * This test is intended to pass 
		 */
	   @Test
	   public void test_equal_arrays() {
	      SimpleIntegerCalculator calc = new SimpleIntegerCalculator();
	      int size = 5;
	      int[] expecteds = new int[5] ;
	      expecteds[0]=0;
	      expecteds[1]=1;
	      expecteds[2]=1;
	      expecteds[3]=2;
	      expecteds[4]=3;
	      int[] series2 = new int[5];
	      for (int i=0;i<=size-1;i++) {
	    	  series2[i] = calc.fibonacci(i);
	      }
	      assertArrayEquals(expecteds, series2);
	   }
	   
		/*
		 * This test is intended to fail 
		 */
	   @Test
	   public void test_subtraction() {
		   SimpleIntegerCalculator calc = new SimpleIntegerCalculator();
		   int result = 3;
		   assertTrue(result == calc.subtract(10, 5));
	   }
	   
}
